=== qcoro/network/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Daniel Vrátil <dvratil@kde.org>
#
# SPDX-License-Identifier: MIT

add_qcoro_library(
    NAME Network
    SOURCES
        qcoroabstractsocket.cpp
        qcorolocalsocket.cpp
        qcoronetworkreply.cpp
        qcorotcpserver.cpp
    CAMELCASE_HEADERS
        QCoroNetwork
        QCoroAbstractSocket
        QCoroLocalSocket
        QCoroNetworkReply
        QCoroTcpServer
    QCORO_LINK_LIBRARIES
        PUBLIC Core
    QT_LINK_LIBRARIES
        PUBLIC Network
)
