=== debian/changelog ===
qcoro (0.4.0-4ubuntu1) jammy; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Update symbols from Ubuntu build logs.

 -- Rik Mills <rikmills@kde.org>  Wed, 16 Mar 2022 11:07:03 +0000

qcoro (0.4.0-4) unstable; urgency=medium

  * Package tests are too flaky - do not let them fail the package
    build.
  * Add Multi-Arch hints for qcoro-*-dev.

 -- Sandro Knauß <hefee@debian.org>  Mon, 07 Mar 2022 11:47:13 +0100

qcoro (0.4.0-3ubuntu1) jammy; urgency=medium

  * Do not run tests at build time. Flaky.
  * Update synbols from Ubuntu build logs.

 -- Rik Mills <rikmills@kde.org>  Fri, 25 Feb 2022 20:56:20 +0000

qcoro (0.4.0-3) unstable; urgency=medium

  [ Sandro Knauß ]
  * Update symbols from buildds for 0.4.0

 -- Sandro Knauß <hefee@debian.org>  Fri, 25 Feb 2022 20:32:10 +0100

qcoro (0.4.0-2) unstable; urgency=medium

  [ Sandro Knauß ]
  * Add dependencies on dev packages to qtX-dev packages.
  * Set correct Debian maintainer information.
  * Add Multi-Arch hints.

 -- Sandro Knauß <hefee@debian.org>  Fri, 25 Feb 2022 20:22:34 +0100

qcoro (0.4.0-1) unstable; urgency=medium

  * Initial release for Debian (Closes: #1006210).

 -- Sandro Knauß <hefee@debian.org>  Mon, 21 Feb 2022 16:18:13 +0100
