=== debian/control ===
Source: qcoro
Section: libs
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Sandro Knauß <hefee@debian.org>
Build-Depends: cmake (>= 3.19~),
               debhelper-compat (= 13),
               dbus-x11,
               pkg-kde-tools,
               qtbase5-dev (>= 5.15.0~),
               qt6-base-dev (>= 6.1.2~),
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/qcoro
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/qcoro.git
Homepage: https://qcoro.dvratil.cz/
Rules-Requires-Root: no

Package: libqcoro5core0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt5 - Core
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt5 actions.
 .
 This is the core library.

Package: libqcoro6core0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt6 - Core
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt6 actions.
 .
 This is the core library.

Package: libqcoro5dbus0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt5 - DBus
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt5 actions.
 .
 This is the DBus library.

Package: libqcoro6dbus0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt6 - DBus
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt6 actions.
 .
 This is the DBus library.

Package: libqcoro5network0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt5 - Network
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt5 actions.
 .
 This is the network library.

Package: libqcoro6network0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt6 - Network
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt6 actions.
 .
 This is the network library.

Package: qcoro-doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Section: doc
Description: C++20 coroutines for Qt5 - documentation & examples
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt actions.
 .
 This package has the examples and documentation files.

Package: qcoro-qt5-dev
Architecture: any
Multi-Arch: same
Depends: libqcoro5core0 (= ${binary:Version}),
         libqcoro5dbus0 (= ${binary:Version}),
         libqcoro5network0 (= ${binary:Version}),
         qtbase5-dev (>= 5.15.0~),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: qcoro-doc
Section: libdevel
Description: C++20 coroutines for Qt5 - development
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt5 actions.
 .
 This package has the development files.

Package: qcoro-qt6-dev
Architecture: any
Multi-Arch: same
Depends: libqcoro6core0 (= ${binary:Version}),
         libqcoro6dbus0 (= ${binary:Version}),
         libqcoro6network0 (= ${binary:Version}),
         qt6-base-dev (>= 6.1.2~),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: qcoro-doc
Section: libdevel
Description: C++20 coroutines for Qt6 - development
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt6 actions.
 .
 This package has the development files.
