=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with pkgkde_symbolshelper

override_dh_auto_clean:
	dh_auto_clean
	rm -rf build-Qt6

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_QT_VERSION=5 -DBUILD_SHARED_LIBS=ON
	dh_auto_configure --builddirectory=build-Qt6  -- -DUSE_QT_VERSION=6 -DBUILD_SHARED_LIBS=ON

override_dh_auto_build:
	dh_auto_build
	dh_auto_build --builddirectory=build-Qt6

override_dh_auto_install:
	dh_auto_install
	dh_auto_install --builddirectory=build-Qt6

override_dh_install-indep:
	dh_install
	rm debian/qcoro-doc/usr/share/doc/qcoro-doc/docs/changelog.md
	rm -r debian/qcoro-doc/usr/share/doc/qcoro-doc/docs/about
	rm -r debian/qcoro-doc/usr/share/doc/qcoro-doc/docs/overrides

override_dh_auto_test:
	- dh_auto_test --no-parallel
