=== debian/watch ===
version=4

https://github.com/danvratil/qcoro/releases /danvratil/qcoro/archive/refs/tags/v([\d.]+).tar.gz
