## qcoro 0.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
-cmake_minimum_required(VERSION 3.19)
-set(qcoro_VERSION 0.4.0)
+cmake_minimum_required(VERSION 3.18.4)
+set(qcoro_VERSION 0.6.0)
 set(qcoro_SOVERSION 0)
 project(qcoro LANGUAGES CXX VERSION ${qcoro_VERSION})
 
@@ -8,10 +8,6 @@
 include(GNUInstallDirs)
 include(CTest)
 include(FeatureSummary)
-
-# Custom includes
-include(GenerateHeaders)
-include(AddQCoroLibrary)
 
 #-----------------------------------------------------------#
 # Options
@@ -21,6 +17,7 @@
 add_feature_info(Examples QCORO_BUILD_EXAMPLES "Build examples")
 option(QCORO_ENABLE_ASAN "Build with AddressSanitizer" OFF)
 add_feature_info(Asan QCORO_ENABLE_ASAN "Build with AddressSanitizer")
+option(QCORO_DISABLE_DEPRECATED_TASK_H "Disable deprecated task.h header" OFF)
 
 if(WIN32 OR APPLE OR ANDROID)
     option(QCORO_WITH_QTDBUS "Build QtDBus support" OFF)
@@ -30,39 +27,17 @@
 add_feature_info(QtDBus QCORO_WITH_QTDBUS "Build QtDBus support")
 option(QCORO_WITH_QTNETWORK "Build QtNetwork support" ON)
 add_feature_info(QtNetwork QCORO_WITH_QTNETWORK "Build QtNetwork support")
-
-#-----------------------------------------------------------#
-# Compiler Settings
-#-----------------------------------------------------------#
-
-set(CMAKE_CXX_STANDARD 20)
-set(CMAKE_AUTOMOC ON)
-
-if (MSVC)
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4 /WX")
-    # Disable warning C5054: "operator '&': deprecated between enumerations of different types" caused by QtWidgets/qsizepolicy.h
-    # Disable warning C4127: "conditional expression is constant" caused by QtCore/qiterable.h
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd5054 /wd4127")
-else()
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Werror -pedantic")
-endif()
-
-if (QCORO_ENABLE_ASAN)
-    if (MSVC)
-        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /fsanitize=address")
-    else()
-        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer")
-    endif()
-endif()
-
-include(qcoro/QCoroMacros.cmake)
-qcoro_enable_coroutines()
+option(QCORO_WITH_QTWEBSOCKETS "Build QtWebSockets support" ON)
+add_feature_info(QtWebSockets QCORO_WITH_QTWEBSOCKETS "Build QtWebSockets support")
 
 #-----------------------------------------------------------#
 # Dependencies
 #-----------------------------------------------------------#
 
+set(THREADS_PREFER_PTHREAD_FLAG TRUE)
 find_package(Threads REQUIRED)
+
+include(cmake/CheckAtomic.cmake)
 
 set(REQUIRED_QT_COMPONENTS Core)
 if (QCORO_WITH_QTDBUS)
@@ -71,6 +46,9 @@
 if (QCORO_WITH_QTNETWORK)
     list(APPEND REQUIRED_QT_COMPONENTS Network)
 endif()
+if (QCORO_WITH_QTWEBSOCKETS)
+    list(APPEND REQUIRED_QT_COMPONENTS WebSockets)
+endif()
 if (QCORO_BUILD_EXAMPLES)
     list(APPEND REQUIRED_QT_COMPONENTS Widgets Concurrent)
 endif()
@@ -79,8 +57,7 @@
 endif()
 
 set(MIN_REQUIRED_QT5_VERSION "5.12")
-# 6.1.2 fixes QTBUG-93270 which prevents compiling against Qt6 with C++20 enabled
-set(MIN_REQUIRED_QT6_VERSION "6.1.2")
+set(MIN_REQUIRED_QT6_VERSION "6.2.0")
 
 
 if (NOT USE_QT_VERSION)
@@ -104,6 +81,69 @@
 )
 
 #-----------------------------------------------------------#
+# Compiler Settings
+#-----------------------------------------------------------#
+
+set(CMAKE_CXX_STANDARD 20)
+set(CMAKE_AUTOMOC ON)
+
+if (MSVC)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4 /WX")
+    # Disable warning C5054: "operator '&': deprecated between enumerations of different types" caused by QtWidgets/qsizepolicy.h
+    # Disable warning C4127: "conditional expression is constant" caused by QtCore/qiterable.h
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd5054 /wd4127")
+
+    if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
+        # Explicitly enable exceptions support for clang-cl (it's only enabled by CMake when targeting the Windows-MSVC platform,
+        # see https://github.com/danvratil/qcoro/issues/90 for details)
+        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHsc")
+    endif()
+else()
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Werror -pedantic")
+endif()
+
+if (QCORO_ENABLE_ASAN)
+    if (MSVC)
+        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /INCREMENTAL:NO")
+        if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
+            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address")
+        else()
+            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /fsanitize=address")
+        endif()
+    else()
+        if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS_EQUAL "11.0.0")
+            # I tried my best, but there are crashes when combining asan and coroutines.
+            message(WARNING "ASAN not supported for Clang<=11.0")
+        else()
+            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer -fsanitize-recover=address")
+        endif()
+    endif()
+endif()
+
+add_compile_definitions(
+    QT_NO_CAST_FROM_ASCII
+    QT_NO_CAST_TO_ASCII
+    QT_NO_URL_CAST_FROM_STRING
+    QT_NO_CAST_FROM_BYTEARRAY
+    QT_USE_STRINGBUILDER
+    QT_NO_NARROWING_CONVERSIONS_IN_CONNECT
+    QT_NO_KEYWORDS
+    QT_NO_FOREACH
+)
+if (NOT WIN32)
+    # strict iterators on MSVC only work when Qt itself is also built with them,
+    # which is not usually the case. Otherwise there are linking issues.
+    add_compile_definitions(QT_STRICT_ITERATORS)
+endif()
+
+include(qcoro/QCoroMacros.cmake)
+qcoro_enable_coroutines()
+
+include(cmake/CodeCoverage.cmake)
+add_code_coverage()
+add_code_coverage_all_targets(EXCLUDE "${CMAKE_BINARY_DIR}" tests/utils/*)
+
+#-----------------------------------------------------------#
 # Definitions
 #-----------------------------------------------------------#
 
@@ -160,5 +200,3 @@
 #-----------------------------------------------------------#
 
 feature_summary(FATAL_ON_MISSING_REQUIRED_PACKAGES WHAT ALL)
-
-
