=== debian/changelog ===
qcoro (0.6.0-4ubuntu1) kinetic; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Update symbols from Ubuntu build logs.

 -- Rik Mills <rikmills@kde.org>  Sun, 07 Aug 2022 08:07:21 +0100

qcoro (0.6.0-4) unstable; urgency=medium

  * Team upload.
  * Backport upstream commit eba5ec31ba7a270df91986f9af94f688151da9e6 to use
    -Werror only in debug builds; patch
    upstream_Only-enable-Werror-and-related-flags-in-debug-mode-f.patch.
    (Closes: #1016282)
  * Update symbols files.

 -- Pino Toscano <pino@debian.org>  Sun, 07 Aug 2022 07:45:15 +0200

qcoro (0.6.0-3ubuntu1) kinetic; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Update symbols from Ubuntu build logs.

 -- Rik Mills <rikmills@kde.org>  Mon, 11 Jul 2022 06:16:17 +0100

qcoro (0.6.0-3) unstable; urgency=medium

  * Team upload.
  * Make the tests fatal again, as they seem to be stable with qcoro 0.6.0.

 -- Pino Toscano <pino@debian.org>  Sun, 10 Jul 2022 20:57:29 +0200

qcoro (0.6.0-2) unstable; urgency=medium

  * Team upload.
  * Enable the QtWebSockets support:
    - drop -DQCORO_WITH_QTWEBSOCKETS=OFF from the cmake arguments
    - add the libqt5websockets5-dev, and libqt6websockets6-dev build
      dependencies
    - add the libqcoro5websockets0, and libqcoro6websockets0 packages
    - add the libqt5websockets5-dev dependency to qcoro-qt5-dev
    - add the libqt6websockets6-dev deoendency to qcoro-qt6-dev

 -- Pino Toscano <pino@debian.org>  Sun, 10 Jul 2022 12:44:29 +0200

qcoro (0.6.0-1ubuntu1) kinetic; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Update symbols from Ubuntu build logs.

 -- Rik Mills <rikmills@kde.org>  Sun, 10 Jul 2022 11:22:45 +0100

qcoro (0.6.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update the build dependencies according to the upstream build system:
    - lower cmake to 3.18.4
  * Disable the QtWebSockets supports for now, as it requires adding new binary
    packages
    - pass -DQCORO_WITH_QTWEBSOCKETS=OFF to cmake
  * Bump Standards-Version to 4.6.1, no changes required.
  * Update symbols files.
  * Update lintian overrides.
  * CI: align to other KDE sources.

 -- Pino Toscano <pino@debian.org>  Sun, 10 Jul 2022 11:34:52 +0200

qcoro (0.5.1-1ubuntu1) kinetic; urgency=medium

  * Update symbols from Ubuntu build logs.

 -- Rik Mills <rikmills@kde.org>  Wed, 04 May 2022 17:33:40 +0100

qcoro (0.5.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update the patches:
    - qcorosignal.diff: drop, fixed upstream

 -- Pino Toscano <pino@debian.org>  Thu, 28 Apr 2022 06:12:29 +0200

qcoro (0.5.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update the patches:
    - upstream_Build-Check-if-libatomic-is-required.patch: drop, backported
      from upstream
  * Update the build dependencies according to the upstream build system:
    - bump qt6-base-dev to 6.2.0
  * Avoid a build failure with GCC 11; patch qcorosignal.diff.
  * Update install files.
  * Update symbols files.
  * Update lintian overrides.

 -- Pino Toscano <pino@debian.org>  Tue, 26 Apr 2022 07:16:54 +0200

qcoro (0.4.0-5) unstable; urgency=medium

  * Team upload.
  * Factorize the common cmake arguments in qt5/qt6 builds in a single
    variable.
  * Pass -DQCORO_BUILD_EXAMPLES=OFF to cmake to disable the build of examples,
    as nothing is done with them.
  * Remove the unused ${shlibs:Depends} substvar from qcoro-doc, qcoro-qt5-dev,
    and qcoro-qt6-dev.
  * Use execute_after_dh_auto_clean & xecute_after_dh_install-indep instead of
    manually calling dh_auto_clean & dh_install.
  * Backport upstream commit 312f2fca861b4c623481da58241a1139e013ef83 to link
    to the atomic library if needed on the architecture; patch
    upstream_Build-Check-if-libatomic-is-required.patch. (Closes: #1008615)
  * Run also the unit tests for the qt6 build in non-fatal mode.
  * Mark the dbus-x11 build dependency as !nocheck, as it is needed only during
    dh_auto_test.

 -- Pino Toscano <pino@debian.org>  Sat, 16 Apr 2022 13:10:32 +0200
