=== debian/control ===
--- 
+++ 
@@ -1,15 +1,18 @@
 Source: qcoro
 Section: libs
 Priority: optional
-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
 Uploaders: Sandro Knauß <hefee@debian.org>
-Build-Depends: cmake (>= 3.19~),
+Build-Depends: cmake (>= 3.18.4~),
                debhelper-compat (= 13),
-               dbus-x11,
+               dbus-x11 <!nocheck>,
                pkg-kde-tools,
                qtbase5-dev (>= 5.15.0~),
-               qt6-base-dev (>= 6.1.2~),
-Standards-Version: 4.6.0
+               libqt5websockets5-dev (>= 5.15.0~),
+               qt6-base-dev (>= 6.2.0~),
+               libqt6websockets6-dev (>= 6.2.0~),
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/qcoro
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/qcoro.git
 Homepage: https://qcoro.dvratil.cz/
@@ -75,10 +78,30 @@
  .
  This is the network library.
 
+Package: libqcoro5websockets0
+Architecture: any
+Multi-Arch: same
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Description: C++20 coroutines for Qt5 - WebSockets
+ QCoro is a C++ library that provide set of tools to make use of C++20
+ coroutines in connection with certain asynchronous Qt5 actions.
+ .
+ This is the web sockets library.
+
+Package: libqcoro6websockets0
+Architecture: any
+Multi-Arch: same
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Description: C++20 coroutines for Qt6 - WebSockets
+ QCoro is a C++ library that provide set of tools to make use of C++20
+ coroutines in connection with certain asynchronous Qt6 actions.
+ .
+ This is the web sockets library.
+
 Package: qcoro-doc
 Architecture: all
 Multi-Arch: foreign
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends},
 Section: doc
 Description: C++20 coroutines for Qt5 - documentation & examples
  QCoro is a C++ library that provide set of tools to make use of C++20
@@ -92,9 +115,10 @@
 Depends: libqcoro5core0 (= ${binary:Version}),
          libqcoro5dbus0 (= ${binary:Version}),
          libqcoro5network0 (= ${binary:Version}),
+         libqcoro5websockets0 (= ${binary:Version}),
          qtbase5-dev (>= 5.15.0~),
+         libqt5websockets5-dev (>= 5.15.0~),
          ${misc:Depends},
-         ${shlibs:Depends}
 Recommends: qcoro-doc
 Section: libdevel
 Description: C++20 coroutines for Qt5 - development
@@ -109,9 +133,10 @@
 Depends: libqcoro6core0 (= ${binary:Version}),
          libqcoro6dbus0 (= ${binary:Version}),
          libqcoro6network0 (= ${binary:Version}),
+         libqcoro6websockets0 (= ${binary:Version}),
          qt6-base-dev (>= 6.1.2~),
+         libqt6websockets6-dev (>= 6.2.0~),
          ${misc:Depends},
-         ${shlibs:Depends}
 Recommends: qcoro-doc
 Section: libdevel
 Description: C++20 coroutines for Qt6 - development
